#include "74HCT595.h"
#include "../anzeige.h"
#include <avr/io.h>

void HCT_init(void) { //Initialisiert die Ausgänge des Mikrocontrollers
  DDR_SHCP |= (1<<PIN_SHCP);
  DDR_DS |= (1<<PIN_DS);
  DDR_STCP |= (1<<PIN_STCP);
  #if HARDWARE_VERSION == 2 //Hardware Version 1 hat diesen Pin auf Masse
  DDR_OE |= (1<<PIN_OE);
  #endif

  PORT_SHCP &= ~(1<<PIN_SHCP);
  PORT_DS &= ~(1<<PIN_DS);
  PORT_STCP &= ~(1<<PIN_STCP);
  #if HARDWARE_VERSION == 2
  PORT_OE &= ~(1<<PIN_OE);
  #endif
}

void HCT_load_byte(unsigned char byte) { //Schreibt ein Byte seriell auf das Schieberegister
  PORT_SHCP &= ~(1<<PIN_SHCP);

  signed char bit;
  for(bit=7; bit>-1; --bit) {
    if (byte  & (1<<(bit))) //Höchstwertiges Bit zuerst lesen
      PORT_DS |= (1<<PIN_DS);
    else
      PORT_DS &= ~(1<<PIN_DS);

    PORT_SHCP |= (1<<PIN_SHCP);
    PORT_SHCP &= ~(1<<PIN_SHCP);
  }
}

void HCT_store(void) { //Kopiert die geladenen Werte auf das Ausgangsregister
  PORT_STCP &= ~(1<<PIN_STCP);
  PORT_STCP |= (1<<PIN_STCP);
  PORT_STCP &= ~(1<<PIN_STCP);
}
